/* list.c - linked list implementation 
           Copyright (C) 2006, 2007 Simeon Simeonov

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software Foundation,
 Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA. */

#include "list.h"

void 
list_init(LinkedList *list)
{

  list->size = 0;
  list->head = NULL;
  list->tail = NULL;

}


int 
list_insert(LinkedList *list, regex_t regexp, unsigned int action) 
{

  DHFRule *new_rule;

  if ((new_rule = (DHFRule *) malloc (sizeof(DHFRule))) == NULL) /* create a new node */
    return -1;

  new_rule->regexp = regexp;
  new_rule->action = action;
  new_rule->next = NULL;

  if (list->size == 0) {
    list->head = new_rule;
    list->tail = new_rule;
  } else {
    list->tail->next = new_rule;
    list->tail = new_rule;
  }

  list->size++;

  return 0;

}


int
list_insert_test(LinkedList *list, const char *rule, regex_t regexp, unsigned int action)
{

  DHFRule *new_rule;

  if ((new_rule = (DHFRule *) malloc (sizeof(DHFRule))) == NULL) /* create a new node */
    return -1;

  new_rule->regexp = regexp;
  new_rule->action = action;
  new_rule->rule = strdup(rule);
  new_rule->next = NULL;

  if (list->size == 0) {
    list->head = new_rule;
    list->tail = new_rule;
  } else {

    list->tail->next = new_rule;
    list->tail = new_rule;

  }

  list->size++;

  return 0;

}
