/*        parser.h - structures and prototypes used by parser.c
              Copyright (C) 2006, 2007 Simeon Simeonov


 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software Foundation,
 Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA. */


#ifndef PARSER_H
#define PARSER_H

#include <stdio.h>

#include "list.h"
#include "language.h"

#define DHF_ACTION_PASS 1
#define DHF_ACTION_BLOCK 0

#define DHF_SMTP_451 1
#define DHF_SMTP_553 0


typedef struct _DHFConf 
{

  unsigned int default_action:1; /* default action for hostnames */
  unsigned int default_unresolved_action:1; /* default action for unresolved hostnames (IPs) */
  unsigned int default_ip_action:1; /* default action for non-matching ip's */

  unsigned int block_host_code:1; /* the smtp block code for hosts */
  unsigned int block_unresolved_code:1; /* ... for unresolved hosts (if default_unresolved_action == DHF_ACTION_BLOCK) */
  unsigned int block_ip_code:1; /* ... for IPs */

} DHFConf;

int parse_dhf_rules(DHFConf *config, LinkedList *list);
int parse_dhf_test_rules(const char * config_file, DHFConf *config, LinkedList *list);

#endif
